Subject: bug#17303: On tty or -nw, (window-body-width) is one column too big.

From: Eli Zaretskii <[email-masked]>
Date: Mon, 21 Apr 2014 09:56:01 +0300

> Date: Sun, 20 Apr 2014 20:39:04 +0000
> Cc: [email-masked]
> From: Alan Mackenzie <[email-masked]>
> 
> > No, it's because the last character in the continued like is in column
> > 78 on a TTY, but in column 79 in a GUI session.  Emacs counts columns
> > in continuation lines starting from the last column in the previous
> > line, as you'd expect.  IOW, the continued line is treated as one long
> > line, and all its columns counted contiguously.
> 
> Yes, this is true, but it's (window-body-width) which is inconsistent
> between GUI and tty.
> 
> > It is true that the "\" character on a TTY takes up one column, and
> > thus leaves only 79 columns for text, but what else can Emacs do?
> 
> Tell me that (window-body-width) is 79, not 80.

It can't.  It's not designed for what you need.  You should use
different APIs for what you want; see below.

> > current-column is it.  Please tell why it doesn't fit your needs.
> 
> current-column provides the "logical" column (e.g. 79).  I need the
> "visual" column (e.g. 0).

Then what you want is '(car (posn-col-row (posn-at-point)))'.  But see
below.

> I'm working on getting follow-mode's scrolling working properly.  I have
> a situation where:
> o - point is at Col 79, this being at the start of a continuation line.
> o - this position is one line below the bottom of the window
> o - (but hasn't been redisplayed yet).
> o - set-window-start has NOT been called with a nil NOFORCE parameter.
> 
> If I were to allow the redisplay without further action, redisplay would
> scroll the window back upwards to ensure point is displayed.  This would
> negate the purpose of the scrolling.  I want to move point back into the
> window before the redisplay.  So I attempt the following:
> o - (setq dest-col (Determine-the-visual-column-point-is-in))
> o - (vertical-motion -1)
> o - (move-to-column dest-col)
> 
> However this last action becomes, on a tty, (move-to-column 79) putting
> point back where it started.  :-(

I think you just need to use pos-visible-in-window-p instead of all
that complexity: if that function returns an indication that point is
not visible, move it back until it is.  There's also the new
pre-redisplay-function hook that you might find useful.

Don't try to outsmart redisplay; instead, ask redisplay to tell you
what it already knows.  The functions I mentioned are interfaces
exposed by redisplay for this very purpose.

So can we close this bug report?